#include <signal.h>
#include <stdio.h>
#include <unistd.h>
#include <time.h>

void print_time() {
  struct tm *p_time;
  time_t now;
  time(&now);
  p_time = localtime(&now);
  printf("%02d:%02d:%02d", 
	 p_time -> tm_hour,
	 p_time -> tm_min,
	 p_time -> tm_sec);
}

void handle_signal(int sig) {
  static int count = 1;
  print_time();
  printf(" Received signal (%d)!\n", count++);
  sleep(5);
  print_time();
  printf(" Carry on.\n");
}

int main() {

  /* Set up signal handler. */
  struct sigaction handle_action;
  handle_action.sa_handler = handle_signal; /* the signal handler */
  sigemptyset (&handle_action.sa_mask);  /* clear the signal set */
  handle_action.sa_flags = 0; /* no special modification to behavior */
  if (sigaction(SIGALRM, &handle_action, NULL) == -1) {
    perror("sigaction");
    return 1;
  }
  if (sigaction(SIGHUP, &handle_action, NULL) == -1) {
    perror("sigaction");
    return 1;
  }

  printf("Pid: %d\n", getpid());

  while (1) {
    printf("Waiting for a signal...\n");
    pause();
  }

  return 0; 
}
