#include <pthread.h>
#include <signal.h>
#include <stdio.h>
#include <unistd.h>

/* Loop forever. */
void *workerDown() {
  int count = 0;
  while (1) {
    count--;
    printf("Count: %d\n", count);
    sleep(5);
  }
}

/* Loop forever. */
void *workerUp() {
  int count = 0;
  while (1) {
    count++;
    printf("Count: %d\n", count);
    sleep(5);
  }
}

void handle_signal(int sig) {
  printf("Received signal!\n");
  sleep(20);
  printf("Carry on.\n");

}

int main() {

  /* Set up signal handler. */
  struct sigaction handle_action;
  handle_action.sa_handler = handle_signal; /* the signal handler */
  sigemptyset (&handle_action.sa_mask);  /* clear the signal set */
  handle_action.sa_flags = 0; /* no special modification to behavior */
  if (sigaction(SIGHUP, &handle_action, NULL) == -1) {
    perror("sigaction");
    return 1;
  }

  /* Print pid. */
  printf("Pid: %d\n", getpid());

  /* Newly spawned thread will count up. */
  pthread_t p;
  if (pthread_create(&p, NULL, workerUp, NULL) != 0) {
    printf("Error! p1: pthread_create failed.");
    return 1;
  }

  /* Main thread will count down. */
  workerDown();

  printf("Children threads have finished.\n");

  return 0; 
}
