/* dup-2.c - illustrate duplicating file descriptors with a pipe. */

#include <unistd.h>
#include <stdio.h>

int main(void) {

  /* Create pipe. */
  int fd[2];
  if (pipe(fd) == -1 ) {
    perror("pipe");
    return 1;
  }

  if (fork() == 0) { /** Child. **/
    dup2(fd[1], STDOUT_FILENO); /* copy pipe out to stdout */
    close(fd[0]);
    close(fd[1]);
    execl("/bin/ls", "ls", "-s", "-1", NULL);
    perror("ls - exec");
  } else {           /** Parent. **/
    dup2(fd[0], STDIN_FILENO);  /* copy pipe in to stdin */
    close(fd[0]);
    close(fd[1]);
    execl("/usr/bin/sort", "sort", "-n", NULL);
    perror("sort - exec");
  }

  /* If we get here, there is an error with exec. */
  return 1;
}
