/* dup.c - illustrate duplicating file descriptors. */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>

int main(void) {
  int fd;

  /* Open file, for temporary use. */
  fd = open("dup.txt", O_WRONLY | O_CREAT, S_IRUSR | S_IWUSR);
  if (fd == -1) {
    perror("open");
    return 1;
  }

  /* Duplicate (copy) new fd to stdout. */
  if (dup2(fd, STDOUT_FILENO) == -1) {
    perror("dup2");
    return 1;
  }

  /* Execute "ls", usually to the screen (stdout) but now to fd. */
  execl("/bin/ls", "ls", "-l", NULL);

  /* If we get here, there is an error with exec. */
  perror("execl");
  return 1;
}
