/*
 * file.c - demonstrate basic IPC through files.
 */

#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>

#define MSG "Hello, world!"

int main(void) {

  /* Open file for communication. */
  int fd = open("file.txt", O_CREAT | O_RDWR | O_TRUNC, S_IWUSR);
  if (fd == -1) {
    perror("open");
    return 1;
  }
  
  /* Create second process to communicate with. */
  int pid = fork();
  if (pid == -1) {
    perror("fork");
    return 1;
  }

  if (pid == 0) {  /** Child. **/
    write(fd, MSG, strlen(MSG)+1);
    printf("Child said: %s\n", MSG);
  } else {        /** Parent. **/
    sleep(1);
    char buff[100];
    read(fd, buff, strlen(MSG)+1);
    printf("Parent heard: %s\n", MSG);
  }

  /* Close file. */
  close(fd);

  /* All is well. */
  return 0;
}
