/* 
 * signal-2.c - illustrate basic signal() and kill()
 */

#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

void handle_signal(int sig) {
  if (sig == SIGUSR1) {
    printf("Recived user-defined signal. Stopping.\n");
    exit(0);
  }
}

int main() {

  /* Set up signal handler. */
  struct sigaction handle_action;
  handle_action.sa_handler = handle_signal; /* the signal handler */
  sigemptyset (&handle_action.sa_mask);  /* clear the signal set */
  handle_action.sa_flags = 0; /* no special modification to behavior */
  if (sigaction(SIGUSR1, &handle_action, NULL) == -1) {
    perror("sigaction");
    return 1;
  }

  int pid = fork();
  if (pid != 0) { /** Parent **/
    sleep(5);
    printf("Sending child signal (%d).\n", SIGUSR1);
    if (kill(pid, SIGUSR1) == -1)
      perror("kill");
  } else {        /** Child **/
    int count = 0;
    while (1) {
      count++;
      printf("%d: Looping...\n", count);
      sleep(1);
    }
  }

  /* All is well. */
  return 0; 
}
