/* 
 * signal.c - illustrate a basic signal()
 */

#include <signal.h>
#include <stdio.h>
#include <unistd.h>

int g_count = 0;

void handle_signal(int sig) {
  if (sig == SIGINT)
    printf("Nya, nya, nya - I can't hear you!\n");
  if (sig == SIGHUP) {
    printf("Resetting g_count to 0.\n");
    g_count = 0;
  }
}

int main() {

  /* Set up signal handler. */
  struct sigaction handle_action;
  handle_action.sa_handler = handle_signal; /* the signal handler */
  sigemptyset (&handle_action.sa_mask);  /* clear the signal set */
  handle_action.sa_flags = 0; /* no special modification to behavior */
  if (sigaction(SIGINT, &handle_action, NULL) == -1) {
    perror("sigaction");
    return 1;
  }
  if (sigaction(SIGHUP, &handle_action, NULL) == -1) {
    perror("sigaction");
    return 1;
  }

  /* Loop forever. */
  while (1) {
    g_count++;
    printf("%d: Waiting for any signal ...\n", g_count);
    pause();
  }

  return 0; /* Will never get here. */
}
