#include <stdio.h>
#include <stdlib.h>
#include "common.h"

// Global variables.
pthread_mutex_t g_mutex;
volatile int g_counter = 0; // Volatile prevents compiler from optimizing away.
int g_loops;

// Do some work.
void *worker(void *arg) {
  int i;
  for (i = 0; i < g_loops; i++) {
    Pthread_mutex_lock(&g_mutex);
    g_counter++;
    Pthread_mutex_unlock(&g_mutex);
  }
  pthread_exit(NULL);
}

int main(int argc, char *argv[]) {

  // Command line arg.
  if (argc != 2) { 
    fprintf(stderr, "usage: threads <loops>\n"); 
    exit(1); 
  } 
  g_loops = atoi(argv[1]); // Assign to g_loops.

  pthread_t p1, p2;
  printf(" Initial value: %d\n", g_counter);
  Pthread_mutex_init(&g_mutex, NULL);
  Pthread_create(&p1, NULL, worker, NULL); 
  Pthread_create(&p2, NULL, worker, NULL);
  Pthread_join(p1, NULL);
  Pthread_join(p2, NULL);
  printf("   Final value: %d\n", g_counter);
  
  return 0;
}

