From: /usr/src/linux-headers-4.4.0-83/arch/x86/include/asm

struct thread_struct {
  /* Cached TLS descriptors: */
  struct desc_struct  tls_array[GDT_ENTRY_TLS_ENTRIES];
  unsigned long    sp0;
  unsigned long    sp;
#ifdef CONFIG_X86_32
  unsigned long    sysenter_cs;
#else
  unsigned short    es;
  unsigned short    ds;
  unsigned short    fsindex;
  unsigned short    gsindex;
#endif
#ifdef CONFIG_X86_32
  unsigned long    ip;
#endif
#ifdef CONFIG_X86_64
  unsigned long    fs;
#endif
  unsigned long    gs;

  /* Save middle states of ptrace breakpoints */
  struct perf_event  *ptrace_bps[HBP_NUM];
  /* Debug status used for traps, single steps, etc... */
  unsigned long           debugreg6;
  /* Keep track of the exact dr7 value set by the user */
  unsigned long           ptrace_dr7;
  /* Fault info: */
  unsigned long    cr2;
  unsigned long    trap_nr;
  unsigned long    error_code;
#ifdef CONFIG_VM86
  /* Virtual 86 mode info */
  struct vm86    *vm86;
#endif
  /* IO permissions: */
  unsigned long    *io_bitmap_ptr;
  unsigned long    iopl;
  /* Max allowed port in the bitmap, in bytes: */
  unsigned    io_bitmap_max;

  /* Floating point and extended processor state */
  struct fpu    fpu;
  /*
   * WARNING: 'fpu' is dynamically-sized.  It *MUST* be at
   * the end.
   */
};
