/*
 * shell-v0.c - do one step of basic shell.
 */

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

int main(int argc, char *argv[]) {

  if (argc < 2) {
    printf("Usage: %s <command>\n", argv[0]);
    return 1;
  }

  /* Create new process, (nearly) identical to current process. */
  if (fork() == 0) {

    /* Child (fork returns 0) - execute command. */
    /* (v - use argv array, p - use path) */
    if (-1 == execvp(argv[1], argv+1)) {
      printf("Unable to execute \"%s\"\n", argv[1]);
      return 1;
    }

  } else

    /* Parent (fork returns child pid) - wait for child to finish. */
    wait(NULL);

  /* Warning!  What else might happen? */
}
