/*--------------------------------------*/
/* Extra stuff needed for system.h.     */
#define NUM_SEMS 50

/* Declare semaphore data structure. */
struct semaphore {
  int allocated;
  int count;
  int use_count;
  int id;
  pid_queue queue;
};

/* Allocate OS semaphore resources. */
struct semaphore sema[NUM_SEMS];
/*--------------------------------------*/

/*
 * semaphore.c - provide a basic OS semaphore.
 */

/* Attach to OS semaphore based on key if there, else allocate. */
/* Return semaphore id, -1 if error. */
int AttachSemaphore(int key) {

  /* Implementaion left as an exercise ... */

  /* Return index (id) of sempahore process will use.*/
  return sid;
}

/* Deattach from semaphore id, unallocate if last. */
/* Return 0 if ok, -1 if error. */
int DetachSemaphore(int sid) {

  /* Implementaion left as an exercise ... */

  /* All is well. */
  return 0;
}

/* Signal semaphore. */
/* Return 0 if ok, -1 if error. */
int SignalSemaphore(int sid) {

  /* Check if semaphore id is invalid (not allocated). */
  if (!sema[sid].allocated)
    return -1;	/* invalid */

  /* Increase semaphore count, waking sleeping process as appropriate. */
  sema[sid].count++;
  if (sema[sid].count <= 0) {
    int pid = remove(sema[sid].queue);
    pd[pid].state = READY;
  }

  /* All is well. */
  return 0;
}

/* Wait on semaphore. */
/* Return 0 if ok, -1 if error. */
int WaitSemaphore(int sid) {
  
  /* Check if semaphore id is invalid (not allocated). */
  if (!sema[sid].allocated)
    return -1;	/* invalid */

  /* Decrease semaphore count, sleeping calling process as appropriate. */
  DISABLE_INTERRUPTS; /* Turn off interrupts for system.*/
  sema[sid].count--;
  if (sema[sid].count < 0) {
    insert(sema[sid].queue, current_process);
    pd[current_process].state = BLOCKED;
    ENABLE_INTERRUPTS; /* Turn interrupts back on.*/
    Dispatcher(); /* Calling process going to sleep.  Schedule new one. */
  } else
    ENABLE_INTERRUPTS; /* Turn interrupts back on.*/

  /* All is well. */
  return 0;
}
