// fork.c

#include <stdio.h>
#include <unistd.h>
#include <errno.h>

int global = 5;

int main(int argc, char *argv[]) {
  int local = 10;

  printf("Start: global %d, local %d\n", global, local);
  int pid = fork();
  if (pid < 0) {   /* Fail. */
    perror("Fork failed.");
    return -1;
  }
  if (pid == 0) {  /* Child. */
    printf(" Child.  My id is %d.\n", getpid());
    global++;
    local++;
  } else {         /* Parent. */
    printf("Parent.  My child id is %d.\n", pid);
    global--;
    local--;
  }
  printf("  End: global %d, local %d\n", global, local);
}
